import Foundation
import UIKit

class AdvancedOptionsController : UIViewController,UIPickerViewDelegate, UIPickerViewDataSource
{
    var billCountryPickerView: UIPickerView!
    var shipCountryPickerView: UIPickerView!
    
    @IBOutlet weak var invoiceTextField: UITextField!
    @IBOutlet weak var poNumberTextField: UITextField!
    @IBOutlet weak var desriptionTextField: UITextField!

    @IBOutlet weak var billFirstNameTextField: UITextField!
    @IBOutlet weak var billLastNameTextField: UITextField!
    @IBOutlet weak var billCompanyTextField: UITextField!
    @IBOutlet weak var billAddressTextField: UITextField!
    @IBOutlet weak var billCityTextField: UITextField!
    @IBOutlet weak var billStateTextField: UITextField!
    @IBOutlet weak var billZipTextField: UITextField!
    @IBOutlet weak var billCountryTextField: UITextField!
    @IBOutlet weak var billPhoneNumberTextField: UITextField!
    @IBOutlet weak var shipFirstNameTextField: UITextField!
    @IBOutlet weak var shipLastNameTextField: UITextField!
    @IBOutlet weak var shipCompanyTextField: UITextField!
    @IBOutlet weak var shipAddressTextField: UITextField!
    @IBOutlet weak var shipCityTextField: UITextField!
    @IBOutlet weak var shipStateTextField: UITextField!
    @IBOutlet weak var shipZipTextField: UITextField!
    @IBOutlet weak var shipCountryTextField: UITextField!
    @IBOutlet weak var shipPhoneNumberTextField: UITextField!

    @IBOutlet weak var custom01TextField: UITextField!
    @IBOutlet weak var custom02TextField: UITextField!
    @IBOutlet weak var custom03TextField: UITextField!
    
    required init?(coder: NSCoder) {
        super .init(coder: coder)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        billCountryPickerView = UIPickerView()
        billCountryPickerView.delegate=self
        billCountryPickerView.dataSource=self
        billCountryTextField.inputView=billCountryPickerView
        
        shipCountryPickerView = UIPickerView()
        shipCountryPickerView.delegate=self
        shipCountryPickerView.dataSource=self
        shipCountryTextField.inputView=shipCountryPickerView
        
        let tap = UITapGestureRecognizer(target: self, action: #selector(dismissKeyboard))
        tap.cancelsTouchesInView=true
        view.addGestureRecognizer(tap)
    }
    
    @IBAction func doneButtonClick(_ sender: Any)
    {
        self.dismiss(animated: true, completion: nil)
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if(pickerView == billCountryPickerView)
        {
            return Country.Countries.count
        }
        else if(pickerView == shipCountryPickerView)
        {
            return Country.Countries.count
        }
        else
        {
            return 0
        }
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if(pickerView == billCountryPickerView)
        {
            return Country.Countries[row] as? String
        }
        else if(pickerView == shipCountryPickerView)
        {
            return Country.Countries[row] as? String
        }
        else
        {
            return ""
        }
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        if(pickerView == billCountryPickerView)
        {
            billCountryTextField.text=Country.Countries[row] as? String
        }
        else if(pickerView == shipCountryPickerView)
        {
            shipCountryTextField.text=Country.Countries[row] as? String
        }
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        if(pickerView == billCountryPickerView)
        {
            return 1
        }
        else if(pickerView == shipCountryPickerView)
        {
            return 1
        }
        else
        {
            return 0
        }
    }
    
    @objc func dismissKeyboard()
    {
        self.view.endEditing(true)
    }
}

struct Country
{
    public static let Countries : NSMutableArray = NSMutableArray(array: [
        "",
        "United States",
        "Canada",
        "Afghanistan",
        "Aland Islands",
        "Albania",
        "Algeria",
        "American Samoa",
        "Andora",
        "Angola",
        "Anguilla",
        "Antarctica",
        "Antigua and Barbuda",
        "Argentina",
        "Armenia",
        "Aruba",
        "Australia",
        "Austria",
        "Azerbaijan",
        "Bahamas",
        "Bahrain",
        "Bangladesh",
        "Barbados",
        "Belarus",
        "Belgium",
        "Belize",
        "Benin",
        "Bermuda",
        "Bhutan",
        "Bolivia",
        "Bosnia and Herzegovina",
        "Botswana",
        "Bouvet Island",
        "Brazil",
        "British Indian Ocean Territory",
        "Brunei Darussalam",
        "Bulgaria",
        "Cambodia",
        "Cameroon",
        "Cape Verde",
        "Cayman Islands",
        "Central African Republic",
        "Chad",
        "Chile",
        "China",
        "Christmas Island",
        "Cocos (Keeling) Islands",
        "Colombia",
        "Comoros",
        "Congo",
        "Cook Islands",
        "Costa Rica",
        "Cote D'Ivoire",
        "Croatia",
        "Cuba",
        "Cyprus",
        "Czech Republic",
        "Denmark",
        "Djibouti",
        "Dominica",
        "Dominican Republic",
        "Ecuador",
        "Egypt",
        "El Salvador",
        "Equatorial Guinea",
        "Eritrea",
        "Estonia",
        "Ethiopia",
        "Falkland Islands (Malvinas)",
        "Faroe Islands",
        "Fiji",
        "Finland",
        "France",
        "French Guiana",
        "French Polynesia",
        "French Southern Territories",
        "Gabon",
        "Gambia",
        "Georgia",
        "Germany",
        "Ghana",
        "Gibraltar",
        "Greece",
        "Greenland",
        "Grenada",
        "Guadeloupe",
        "Guam",
        "Guatemala",
        "Guernsey",
        "Guinea",
        "Guinea-Bissau",
        "Guyana",
        "Haiti",
        "Heard Island and Mcdonald Islands",
        "Holy See (Vatican City State)",
        "Honduras",
        "Hong Kong",
        "Hungary",
        "Iceland",
        "India",
        "Indonesia",
        "Iran, Islamic Republic Of",
        "Iraq",
        "Ireland",
        "Isle of Man",
        "Israel",
        "Italy",
        "Jamaica",
        "Japan",
        "Jersey",
        "Jordan",
        "Kazakhstan",
        "Kenya",
        "Kiribati",
        "Korea, Democratic People's Republic of",
        "Korea, Republic of",
        "Kuwait",
        "Kyrgyzstan",
        "Lao People's Democratic Republic",
        "Latvia",
        "Lebanon",
        "Lesotho",
        "Liberia",
        "Libyan Arab Jamahiriya",
        "Liechtenstein",
        "Lithuania",
        "Luxembourg",
        "Macao",
        "Maceonia, The Format Yugoslav Republic of",
        "Madagascar",
        "Malawi",
        "Malaysia",
        "Maldives",
        "Mali",
        "Malta",
        "Marshall Islands",
        "Martinique",
        "Mauritania",
        "Mauritius",
        "Mayotte",
        "Mexico",
        "Micronesia, Federated States of",
        "Moldova, Republic of",
        "Monaco",
        "Mongolia",
        "Montserrat",
        "Morocco",
        "Mozambique",
        "Myanmar",
        "Namibia",
        "Nauru",
        "Nepal",
        "Netherlands",
        "Netherlands Antilles",
        "New Caledonia",
        "New Zealand",
        "Nicaragua",
        "Niger",
        "Nigeria",
        "Niue",
        "Norfolk Island",
        "Northern Mariana Islands",
        "Norway",
        "Oman",
        "Pakistan",
        "Palau",
        "Palestinian Territory, Occupied",
        "Panama",
        "Papua New Guinea",
        "Paraguay",
        "Peru",
        "Philippines",
        "Pitcairn",
        "Poland",
        "Portugal",
        "Puerto Rico",
        "Qatar",
        "Reunion",
        "Romania",
        "Russian Federation",
        "Rwanda",
        "Saint Helena",
        "Saint Kitts and Nevis",
        "Saint Lucia",
        "Saint Pierre and Miquelon",
        "Saint Vincent and the Grenadines",
        "Samoa",
        "San Marino",
        "Sao Tome and Principe",
        "Saudi Arabia",
        "Senegal",
        "Serbia and Montenegro",
        "Seychelles",
        "Sierra Leone",
        "Singapore",
        "Slovakia",
        "Slovenia",
        "Solomon Islands",
        "Somalia",
        "South Africa",
        "South Georgia and the South Sandwish Islands",
        "Spain",
        "Sri Lanka",
        "Sudan",
        "Suriname",
        "Svalbard and Jan Mayen",
        "Swaziland",
        "Sweden",
        "Switzerland",
        "Syrian Arab Republic",
        "Taiwan, Province of China",
        "Tajikistan",
        "Tanzania, United Republic of",
        "Thailand",
        "Timor-Leste",
        "Togo",
        "Tokelau",
        "Tonga",
        "Trinidad and Tobago",
        "Tunisia",
        "Turkey",
        "Turkmenistan",
        "Turks and Caios Islands",
        "Tuvalu",
        "Uganda",
        "Ukraine",
        "United Arab Emirates",
        "United Kingdom",
        "United States Minor Outlying Islands",
        "Uruguay",
        "Uzbekistan",
        "Vanuatu",
        "Venezuela",
        "Viet Nam",
        "Virgin Islands, British",
        "Virgin Islands, U.S.",
        "Wallis and Futuna",
        "Western Sahara",
        "Yemen",
        "Zambia",
        "Zimbabwe"])
}
